<?php
function icp_ui_settings() {
    global $icp;

    ?>
    <h2><?php $icp->Lang->P('Title.Settings')?></h2>
    <?php

    $icp->Form->prefix='License';
    if($icp->Check->nonce('icp_settings')) {
        if($icp->Check->is('_action', 'Save')) {
            if($icp->License->hasPremium() && $icp->Utils->iqs('noOtherSettings')==0) {
                /* @var $newSettings ICP_PluginSettings */
                $newSettings=$icp->Dao->Utils->qs('ICP_PluginSettings');
                $icp->Options->setPluginSettings($newSettings);
            }
        }
    }

    $settings=$icp->Options->getPluginSettings();
    $icp->Options->writeMessages();

    $icp->Form->formStarts();
    {
        if ($icp->License->hasPremium()) {
            $icp->Form->openPanel('PluginSection');
            {
                $fields='allowUsageTracking';
                $icp->Form->inputsForm($fields, $settings);
            }
            $icp->Form->closePanel();
        } else {
            $icp->Form->hidden('noOtherSettings', 1);
        }

        $icp->Form->openPanel('LicenseSection');
        {
            $fields='licenseKey';
            $icp->Form->inputsForm($fields, $settings);
            if ($icp->License->type() === 'EDD') {
                if ($icp->License->hasPremium()) {
                    $options=array('readonly'=>'readonly');
                    $text='UNLIMITED';
                    if($settings->licenseSiteCount>0) {
                        $text='N.'.$settings->licenseSiteCount;
                    }
                    if($settings->licensePlan>0) {
                        $text.=' ('.$icp->Lang->L('Plan'.$settings->licensePlan).')';
                    }
                    $icp->Form->text('licenseSiteText', $text, $options);
                }
            }
            $icp->Form->nonce('icp_settings');
            $buttons=array();
            $button=array(
                'submit'=>TRUE
            );
            $buttons['Save']=$button;
            $options=array('buttons'=>$buttons);
        }
        $icp->Form->closePanel($options);
    }
    $icp->Form->formEnds();
}