<?php
if ( ! defined( 'ABSPATH' ) ) exit;

define('ICP_LICENSE_SERVER', 'https://intellywp.com/');
define('ICP_EDD_NAME', 'Evergreen Countdown Timer');
class ICP_License {

    public function __construct() {
        //add_filter('cron_schedules', array($this, 'add_schedules'));
        //add_action('wp', array($this, 'schedule_Events'));
        //add_action('icp_daily_scheduled_events', array($this, 'checkLicense'));
		add_action('admin_init', array($this, 'pluginUpdater'));
    }

    function type()
    {
        return 'EDD';
    }

    function pluginUpdater() {
        global $icp;

		if ( $icp->Options->getExpiredLicense() == true )
			return;

        $args=array(
            'version' => ICP_PLUGIN_VERSION
            , 'license'=> $icp->Options->getLicenseKey()
            , 'item_name' => ICP_EDD_NAME
            , 'author' 	=> ICP_PLUGIN_AUTHOR
        );
        $ecUpdater=new ICP_EDD_SL_Plugin_Updater(ICP_LICENSE_SERVER, ICP_PLUGIN_FILE, $args);
    }

    //activate the new license key
    function activate($key) {
        global $icp;

        $settings=$icp->Options->getPluginSettings();
        $old=$icp->Options->getLicenseKey();
        if($old!==FALSE && $old!='') {
            $this->deactivate();
        }

        $options=array(
            'edd_action'=> 'activate_license'
            , 'license'=> $key
            , 'item_name'=> urlencode(ICP_EDD_NAME)
            , 'url'=> home_url()
            , 'wpRemoteGet'=>FALSE
        );
        $result=FALSE;
        $data=$icp->Utils->remoteGet(ICP_LICENSE_SERVER, $options);
        $icp->Options->setLicense(FALSE);
        $settings->licenseKey='';
        $settings->licenseSiteCount=-1;
        $settings->licensePlan=0;
        if($data!==FALSE && isset($data->license)) {
            $result=strtolower($data->license)=='valid';
            $icp->Options->setLicense($data);
            $icp->Options->setLicenseSuccess($result);
            $icp->Options->setExpiredLicense(FALSE);
            if($result) {
                $icp->Options->setLicenseKey($key);
                $settings->licenseKey=$key;
                $v=$icp->Utils->iget($data, 'license_limit', 0);
                $settings->licenseSiteCount=$v;
                $settings->allowUsageTracking=TRUE;
            }
        }
        $icp->Options->setPluginSettings($settings);
        return $result;
    }

    //deactivate the installed license
    function deactivate() {
        global $icp;

        // data to send in our API request
        $settings=$icp->Options->getPluginSettings();
        $options=array(
            'edd_action'=> 'deactivate_license'
            , 'license'=> $icp->Options->getLicenseKey()
            , 'item_name' => urlencode(ICP_EDD_NAME) // the name of our product in EDD
            , 'url' => home_url()
            , 'wpRemoteGet'=>FALSE
        );
        $result=FALSE;
        $data=$icp->Utils->remoteGet(ICP_LICENSE_SERVER, $options);
        $icp->Options->setLicense(FALSE);
        if($data!==FALSE && isset($data->license)) {
            $icp->Options->setLicense($data);
            $icp->Options->setLicenseKey('');
            $icp->Options->setLicenseSuccess(FALSE);
            $icp->Options->setExpiredLicense(FALSE);
            $settings->licenseKey='';
            $settings->licenseSiteCount=-1;
            $settings->licensePlan=0;
            $result=TRUE;
        }
        $icp->Options->setPluginSettings($settings);
        return $result;
    }

    //retrieve if the current license used is stil valid or not
    public function hasPremium($override=FALSE) {
        global $icp;

        $result=FALSE;
        if($icp->Options->getLicenseKey()=='') {
            $result=FALSE;
        } else {
            $check=$icp->Options->getLicenseLastCheck();
            if(!$override && $check>strtotime('-1 day')) {
                $result=intval($icp->Options->isLicenseSuccess())>0;
            } else {
                $result=$this->check();
            }
        }
        return $result;
    }
    public function check() {
        global $icp;

        $result=FALSE;
        if($icp->Options->getLicenseKey()=='') {
            $result=FALSE;
        } else {
            $options=array(
                'edd_action' => 'check_license'
                , 'license' => $icp->Options->getLicenseKey()
                , 'item_name' => urlencode(ICP_EDD_NAME)
                , 'url' => home_url()
                , 'wpRemoteGet'=>FALSE
            );
            $icp->Options->setLicense(FALSE);
            $data=$icp->Utils->remoteGet(ICP_LICENSE_SERVER, $options);
            if($data!==FALSE && isset($data->license)) {
                $icp->Options->setLicense($data);
                if($data->license == 'valid' || $data->license == 'expired') {
					if($data->license == 'expired') {
						$icp->Options->setExpiredLicense(TRUE);
					} elseif($data->license == 'valid') {
						$icp->Options->setExpiredLicense(FALSE);
					}
                    $icp->Options->setLicenseSuccess(TRUE);
                    $result=TRUE;
                } else {
                    $icp->Options->setLicenseSuccess(FALSE);
                }
                $icp->Options->setLicenseLastCheck(time());
            }
        }
        return $result;
    }
}